// most of the examples here are typical of constructor chaining
// the last example using class F requires complete knowledge of chaining rules!
// (and is usually considered too much to ask for Prelims, though it used to show up)

/* Chaining rules:
   - set all fields to "zero"
   - start w/constructor of initialized object
   - chain with "this"
   - last constructor must call super
     call super() if not explicit
     do not finish constructor code yet!
   - call constructor of super class and chain with "this" and "super" again
     stop when reaching Object
   - initialize fields of Object
   - finish running Object's constructor
   - initialize fields of class "below" Object
   - finish running that class's constructor code
   - continue down to your last class (the object)
*/

public class ConstructorSuper {

    public static void main(String[] args) {

	A a;
	a = new B(); a.printX(); // 1
	a = new C(); a.printX(); // 1
	a = new D(); a.printX(); // 2
	a = new E(); a.printX(); // 3

	a = new F(); a.printY(); // ?
    }

}

class A {
    public int x;
    public int y=1;
    public A() { x = 1; }
    public A(int x) { this.x = x; }
    public A(int a, int b) { this(a+b); }
    public void printX() { System.out.println(x); }

    public A(boolean tmp) { printY(); }
    public void printY() { System.out.println(y); } 
}

class B extends A { }

class C extends A {
    C() { super(); }
}

class D extends A {
    D() { super(2); }
}

class E extends A {
    E() { super(1,2); }
}

class F extends A {
    public int y=2;
    public F() { super(true); }
    public void printY() { System.out.println(y); }
}
    
