// example using:
// - interface
// - abstract class (and abstract method)
// - covariant return type
// - downcasting
// - instanceof
// - constructor chaining

interface Addable {
    public abstract Number add(Number other);
}

public class InterfaceAbstract {
    public static void main(String[] args) {
	
	Number n1 = new Double(10);
	Number n2 = new Double(20);
	System.out.println(n1.add(n2));
    }
    
}

abstract class Number {
    protected double value;
    public Number(double value) { this.value=value; }
    public double getValue() { return value; }
    public abstract Number add(Number other);
    public String toString() { return ""+value; }
}


class Double extends Number implements Addable {
    public Double(double value) { super(value); }
    public Double add(Number other) {
	if (other instanceof Double)
	    return new Double( ((Double)other).getValue() + value);
	return null;
    }
}

/* 
   suggested exercises: 
   write Complex, Interval, Integer...
   write add methods to add mixed number types together
   (you would need to decide what can promote and what can't)
*/
