// adapted from http://java.sun.com/docs/books/tutorial/java/IandI/override.html
// What happens with static methods?

public class StaticTest {
    
    public static void main(String[] args) {
        Cat myCat = new Cat();
        Animal myAnimal = myCat;

        myCat.testInstanceMethod();
        myCat.testClassMethod();
        myAnimal.testInstanceMethod();
        myAnimal.testClassMethod();
    }
}

class Animal {
    public static void testClassMethod() {
        System.out.println("The class method in Animal.");
    }
    public void testInstanceMethod() {
        System.out.println("The instance method in Animal.");
    }
}

class Cat extends Animal {
    public static void testClassMethod() {
        System.out.println("The class method in Cat.");
    }
    public void testInstanceMethod() {
        System.out.println("The instance method in Cat.");
    }


}

/*
  The instance method in Cat.
  The class method in Cat.
  The instance method in Cat.
  The class method in Animal.
*/
